/**
 * Copyright (c) 2005, David Holm
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of the project nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

	.section ".bss"
	.global _stack_bottom
	.global _stack_top
_stack_bottom:
	.lcomm _stack, 4096, 16
_stack_top:


	.section ".text"
	.align 2
	.global _start;
_start:
	/* Clear the BSS section as demanded by ANSI C */
	lis	r10, __bss_start@ha
	ori	r10, r10, __bss_start@l
	subi	r10, r10, 4
	lis	r11, _end@ha
	ori	r11, r11, _end@l
	subi	r11, r11, 4
	li	r0, 0
1:	stwu	r0, 4(r10)
	cmp	r0, r10, r11
	bne	1b

	/* Load our stack */
	lis	r1, _stack_top@ha
	ori	r1, r1, _stack_top@l
	addi	r1, r1, -32

	/* Initialise the reserved register */
	li	r2, 0
	/* Point the small data area at 0 */
	li	r13, 0

	/* Jump to the C-code entry point */
	b	loader

